/*
  ACDC - popular AUDIO Compact Disk player 4  LiNUX

   made by Tomaz Ocepek
   	   Mitja Slenc
  
  the source code is kinda wanky, not well documented, err anyway
  who needs those wanky comments anyway :)
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/utsname.h>
#include <unistd.h>
#include <termios.h>
#include <mntent.h>
#include <getopt.h>
#include "struct.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ncurses/curses.h>
#define MAX(a,b) ((a)>(b)?(a):(b))
#define MIN(a,b) ((a)<(b)?(a):(b))
#define DADIR "/usr/local/info/acdc/"


char *cur_trackname;		/* Take a guess */
int cur_index = 0;		/* Current index mark */
int cur_frame;			/* Current frame number */
struct play *playlist = NULL;
struct cdinfo thiscd, *cd = &thiscd;
int cur_track = -1;		/* Current track number, starting at 1 */
char *cur_artist;
char cur_avoid;			/* Avoid flag */
char cur_contd;			/* Continued flag */
char *cur_cdname;		/* Album name */
int cur_nsections;		/* Number of sections currently defined */
int exit_on_eject = 0;

int cur_balance = 10, info_modified;
int cur_pos_abs, cur_pos_rel, cur_tracklen, cur_cdlen, cur_cdmode,
  cur_ntracks, cur_lasttrack, cur_firsttrack, cur_listno, cur_volume=22;
char tmptime[100];
char *tottime;
int autoplay=1;
char *putinstatus=0, pislen=0;
int muted=0;
int sincelast=0,what=0;
int sincepressed=100;
int hilited=0,hilitelen=0;

char playit[100];

int lastplaymode=0,playmode,whichtrack;
int selection=1;
int wait=0,reverse=0;
int initwait=10;
int editing=0;

int asd=5;
int dumbi=0;

#define MODE_NORMAL      0
#define MODE_AUTOLOOP    1
#define MODE_AUTOLOOPONE 2
#define MODE_STOPAFTER   3
#define MODE_RANDOM      4

#define MAXMODES 2 

#define CDNULL  0
#define CDPLAY  1
#define CDPAUZ  3
#define CDSTOP  4
#define CDEJECT 5

#define makebox(a,b,c,d,e,colz) damakebox(a,b,c,d,e,1,colz)
#define makebox2(a,b,c,d,e,colz) damakebox(a,b,c,d,e,0,colz)
#define ABS(a) ((a)>0?(a):-(a))
 
int boxchars[MAXMODES][8]={
  { 0, 0, 0, 0, 0, 0, 0, 0 },
  { '+', '+', '+', '+', '-', '-', '|', '|' }
};


extern void init();
extern void damakebox(int x1, int y1, int x2, int y2, int grafmode, int corners, int colz);
extern void dastrbox(int x1, int y1, int x2, int y2, int grafmode, char *str, int corn, int colz);
extern void strbox(int x1, int y1, int x2, int y2, int grafmode, char *str, int colz);
extern void strbox2(int x1, int y1, int x2, int y2, int grafmode, char *str, int colz);
extern void dapanel(int x1, int y1, int x2, int y2, int grafmode, char *str, int corn, int colz, int colz1, int atribut);
extern void panel(int x1, int y1, int x2, int y2, int grafmode, char *str, int colz, int colz1, int atribut);
extern void dastrpanel(int x1, int y1, int x2, int y2, int grafmode, char *title, char *str, int corn, int colz, int colz1);
extern void dastrpanelspc(int x1, int y1, int x2, int y2, int grafmode, char *title, char *str, int specch, int corn, int colz, int colz1);
extern void strpanel(int x1, int y1, int x2, int y2, int grafmode, char *title, char *str, int colz, int colz1);
extern void strpanelspc(int x1, int y1, int x2, int y2, int grafmode, char *title, char *str, int specch, int colz, int colz1);
extern int countlines(char *str,int w);
extern void getline(char *src, int line, int w, char *buff);
extern void dohilite(int a);
extern void do_volume_panel(void);
extern void printtime(int y, int x, int time);
extern void play_sign(void);
extern void savedashit();
extern void load();
extern void print_cmt_insignia();


void hilite(int a)
{
  if (hilited) {
    attrset(A_NORMAL);
    dohilite(hilited);
  }
  hilited=a;
  if (a) {
    attrset(A_BOLD);
    dohilite(a);
    attrset(A_NORMAL);
    hilitelen=2;
  }
}

int putmstr(int y, int x, int w, int l, char *str)
{
  char buff[1000];
  int cl;
  int n;

  if (!str) return 1;

  cl=countlines(str,w);

  if (ABS(l)>=cl)
    l=l<0?-cl:cl;

  if (l<0) {
    for (n=0; n>l; n--) {
      getline(str,cl+n,w,buff);
      mvaddstr(y+n,x,buff);
    }
  } else {
    for (n=0; n<l; n++) {
      getline(str,n+1,w,buff);
      mvaddstr(y+n,x,buff);
    }
  }
  return ABS(l);
}


int lastlinelen(char *a, int w)
{
  static char buff[1000];
  
  getline(a,countlines(a,w),w,buff);
  return strlen(buff);
}


void updatedisp(int clear) {

  char buff[1000];
  int a,b,c,n,i,j=0;
  int height;
  int sel;

  if (clear) {
  
    clear();
    
    makebox(0,0,79,LINES-1,0,COLOR_PAIR(1));
    attrset(A_BOLD); mvaddch(0,0,ACS_ULCORNER); mvaddch(0,79,ACS_URCORNER);
    mvaddch(LINES-1,0,ACS_LLCORNER); mvaddch(LINES-1,79,ACS_LRCORNER); 
    attrset(A_NORMAL);
    attron(COLOR_PAIR(6)|A_BOLD); mvaddstr(1,15,"ACDC"); attron(COLOR_PAIR(1)); attrset(A_NORMAL);
    mvaddstr(1,20,"- popular"); attroff(COLOR_PAIR(6)|A_BOLD);
    attron(COLOR_PAIR(4)|A_BOLD); mvaddstr(1,30,"AUDIO Compact Disk");
    attron(COLOR_PAIR(1)); attrset(A_NORMAL); mvaddstr(1,49,"player 4  LiNUX");
    attroff(COLOR_PAIR(1));
    for(j=15;j<62;j=j+4)
    {
      attron(COLOR_PAIR(1)); attrset(A_BOLD); 
      mvaddch(2,j,'='); attrset(A_NORMAL); mvaddch(2,j+2,'-');
    }  attroff(COLOR_PAIR(1)); attrset(A_BOLD); mvaddch(2,j,'='); 
    attron(COLOR_PAIR(1)|A_BOLD);
    for(j=1;j<7;j++) 
    { 
      mvaddch(0,j,ACS_HLINE); mvaddch(0,79-j,ACS_HLINE);
      mvaddch(LINES-1,j,ACS_HLINE); mvaddch(LINES-1,79-j,ACS_HLINE);
    }
        
    mvaddch(1,0,ACS_VLINE); mvaddch(1,79,ACS_VLINE);
    mvaddch(LINES-2,0,ACS_VLINE); mvaddch(LINES-2,79,ACS_VLINE);
    attrset(A_NORMAL);
    
  /* x1,y1,z2,y2,boxstyle,box color,string color,A_BOLD or A_NORMAL text */
  /* if (LINES!=25) */
  {
    panel(4,   4, 8,   6,  0,"7",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD);
    panel(8,   4, 12,  6,  0,"8",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD); 
    panel(12,  4, 16,  6,  0,"9",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD);
    panel(4,   6, 8,   8,  0,"4",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD);  
    panel(8,   6, 12,  8,  0,"5",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD); 
    panel(12,  6, 16,  8,  0,"6",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD);
    panel(4,   8, 8,  10,  0,"1",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD);  
    panel(8,   8, 12, 10,  0,"2",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD); 
    panel(12,  8, 16, 10,  0,"3",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD);
    panel(4,  10, 12, 12, 0,"0",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD); 
    panel(12, 10, 16, 12, 0,".",COLOR_PAIR(2),COLOR_PAIR(4),A_BOLD);
    
    attron(COLOR_PAIR(2));
    mvaddch(4,8,ACS_TTEE); mvaddch(6,8,ACS_PLUS); mvaddch(8,8,ACS_PLUS); mvaddch(10,8,ACS_BTEE);
    mvaddch(4,12,ACS_TTEE); mvaddch(6,12,ACS_PLUS); mvaddch(8,12,ACS_PLUS); mvaddch(10,12,ACS_BTEE);
    mvaddch(6,4,ACS_LTEE); mvaddch(8,4,ACS_LTEE); mvaddch(10,4,ACS_LTEE); mvaddch(10,12,ACS_PLUS);
    mvaddch(12,12,ACS_BTEE); mvaddch(10,16,ACS_RTEE); mvaddch(6,16,ACS_RTEE); mvaddch(8,16,ACS_RTEE);
    attroff(COLOR_PAIR(1)); attrset(A_NORMAL);
    
    strpanelspc(50,4,61,6,0," F1 ","PLAY  ",ACS_RARROW,COLOR_PAIR(3),COLOR_PAIR(4));
    attron(COLOR_PAIR(5)|A_BOLD); mvaddch(5,58,'|'); attrset(A_NORMAL);
    strpanelspc(65,4,76,6,0," F2 ","STOP  ",ACS_BULLET,COLOR_PAIR(3),COLOR_PAIR(4));
    attron(COLOR_PAIR(5)|A_BOLD); mvaddch(5,73,ACS_BULLET); attrset(A_NORMAL);

   /* a little routine for the big box with 4 diff. functions :) */
    strpanel(50,7,76,9,0,"","",COLOR_PAIR(3),COLOR_PAIR(4));
    attron(COLOR_PAIR(1)); mvaddstr(7,51," F3 "); mvaddstr(7,59," F4 ");
    mvaddstr(7,64," F5 "); mvaddstr(7,72," F6 "); 
    attroff(COLOR_PAIR(1)); attron(COLOR_PAIR(4));
    mvaddstr(8,55,"SKIP"); mvaddstr(8,68,"SCAN"); attroff(COLOR_PAIR(4));
    attrset(A_BOLD); attron(COLOR_PAIR(5)); 
    mvaddch(8,52,ACS_BULLET); mvaddch(8,53,ACS_LARROW); mvaddch(8,60,ACS_RARROW);
    mvaddch(8,61,ACS_BULLET); mvaddch(8,65,ACS_LARROW); mvaddch(8,66,ACS_LARROW);
    mvaddch(8,73,ACS_RARROW); mvaddch(8,74,ACS_RARROW);
    attroff(COLOR_PAIR(5));
    attrset(A_NORMAL);
   /* that ends here */ 
   }
  }
   
  if ((lastplaymode!=playmode) || clear) {
    reverse=0;
    switch(lastplaymode) {
      case MODE_NORMAL: break;
      case MODE_AUTOLOOP: strpanel(64,10,76,12,0," A N S R ","Play:   ALL",COLOR_PAIR(3),COLOR_PAIR(4)); break;
      case MODE_AUTOLOOPONE: strpanel(64,10,76,12,0," A N S R ","Play:   ONE",COLOR_PAIR(3),COLOR_PAIR(4)); break;
      case MODE_STOPAFTER: strpanel(64,10,76,12,0," A N S R ","Stop  after",COLOR_PAIR(3),COLOR_PAIR(4)); break;
      case MODE_RANDOM: strpanel(64,10,76,12,0," A N S R ","Play:   RND",COLOR_PAIR(3),COLOR_PAIR(4)); break;
    }
    reverse=0;
    switch(playmode) {
      case MODE_NORMAL: break;
      case MODE_AUTOLOOP: strpanel(64,10,76,12,0," A N S R ","Play:   ALL",COLOR_PAIR(3),COLOR_PAIR(4)); break;
      case MODE_AUTOLOOPONE: strpanel(64,10,76,12,0," A N S R ","Play:   ONE",COLOR_PAIR(3),COLOR_PAIR(4)); break;
      case MODE_STOPAFTER: strpanel(64,10,76,12,0," A N S R ","Stop  after",COLOR_PAIR(3),COLOR_PAIR(4)); break;
      case MODE_RANDOM: strpanel(64,10,76,12,0," A N S R ","Play:   RND",COLOR_PAIR(3),COLOR_PAIR(4)); break;
    }
    reverse=0;
    lastplaymode=playmode;
  }

  mvaddstr(11,51,"           ");
  switch (cd_status()) {
    case 0: strpanel(50,10,61,12,0," Status ","  No  CD  ",COLOR_PAIR(3),COLOR_PAIR(4)); break;
    case 1: {
      switch(cur_cdmode) {
        case 0: strpanel(50,10,61,12,0," Status ","Stopped ",COLOR_PAIR(3),COLOR_PAIR(4)); break;
        case 1: play_sign(); break;
        case 2: break;
        case 3: strpanel(50,10,61,12,0," Status "," Paused  ",COLOR_PAIR(3),COLOR_PAIR(4)); break;
        case 4: strpanel(50,10,61,12,0," Status ","CD Stopped",COLOR_PAIR(3),COLOR_PAIR(4)); break;
        case 5: strpanel(50,10,61,12,0," Status "," Ejecting ",COLOR_PAIR(3),COLOR_PAIR(4)); break;
      }
    } break;
    case 2: strpanel(50,10,61,12,0," Status ","DoorClosed",COLOR_PAIR(3),COLOR_PAIR(4)); break;
    case 3: strpanel(50,10,61,12,0," Status "," Removed ",COLOR_PAIR(3),COLOR_PAIR(4)); break;
  } 
  if (pislen) {
    strpanel(50,10,61,12,0," Status ","         ",COLOR_PAIR(3),COLOR_PAIR(4));
    strpanel(50,10,61,12,0," Status ",putinstatus,COLOR_PAIR(3),COLOR_PAIR(4));
    pislen--;
  }

  strpanel(21,4,45,6,0," Volume  F7 <-> F8 ","",COLOR_PAIR(3),COLOR_PAIR(4));
  do_volume_panel();  

  strpanel(21,7,45,14,0," CD info ","",COLOR_PAIR(3),COLOR_PAIR(4));
  attron(COLOR_PAIR(1)); mvaddstr(14,27," TRACK  info "); attroff(COLOR_PAIR(1));

  /* text for cd info */
  mvaddstr( 8,23,"Total :     "); mvaddstr( 9,23,"Left  :     ");  


  /* text for track info */
  mvaddstr(11,23,"Total :     "); mvaddstr(12,23,"Left  :     ");
  mvaddstr(13,23,"Played:     ");
  
  /* for the cd and track info TIME report */ 
  if (cur_track>=0) {
    attron(COLOR_PAIR(7)|A_BOLD);

    printtime(8,39,cur_cdlen);
    printtime(9,39,cur_cdlen-cur_pos_abs);

    printtime(11,39,cur_tracklen);
    printtime(12,39,cur_tracklen-cur_pos_rel);
    printtime(13,39,cur_pos_rel);

    attroff(COLOR_PAIR(7)); attrset(A_NORMAL);
  } 

  /* prints the track being played */
  mvaddstr(14,50,"Playing track:");  
  if (sincelast) attron(A_BLINK);
  sprintf(buff,"%d  ",sincelast?what:cur_track);
  attron(COLOR_PAIR(5)); mvaddstr(14,66,buff); attroff(COLOR_PAIR(7));
  if (sincelast) attrset(A_NORMAL); 


  b=countlines(cur_artist,68)+countlines(cur_cdname,68);

  if (LINES==25) {
    for (c=17; c<=17+b+2; c++) {
      mvaddstr(c,2,"                                                                             ");
    }  
  }
  if (LINES==28) {
    for (c=17; c<=17+b+5; c++) {
      mvaddstr(c,2,"                                                                             ");
    }  
  }
  if (LINES==30) {
    for (c=17; c<=17+b+7; c++) {
      mvaddstr(c,2,"                                                                             ");
    }  
  }
  if (LINES==34) {
    for (c=17; c<=17+b+11; c++) {
      mvaddstr(c,2,"                                                                             ");
    }  
  }
  
  /* do the CMt insignia at the left bottom screen */
  print_cmt_insignia();
  
  
  attron(COLOR_PAIR(3)); for (a=0;a<4;a++) mvaddch(16,3+a,ACS_HLINE); attroff(COLOR_PAIR(3));
  mvaddstr(16,7," F11/F12 ");
  attron(COLOR_PAIR(3)); for (a=0;a<9;a++) mvaddch(16,16+a,ACS_HLINE); attroff(COLOR_PAIR(3));


  /* for the ARTIST and ALBUM display */
  if (LINES!=25) {
    a=17;
    attrset(A_BOLD); attron(COLOR_PAIR(1));
    mvaddstr(a,2,"Artist: "); attroff(COLOR_PAIR(1));
    attrset(A_NORMAL); attron(COLOR_PAIR(6)); a++;
    if (cur_track>=0) a+=putmstr(a,3,20,2,cur_artist); else a=a+2;
    if (countlines(cur_artist,20)<3) a++;
    attroff(COLOR_PAIR(6));
    attrset(A_BOLD); attron(COLOR_PAIR(1));
    mvaddstr(a,2,"Album: "); a++; attroff(COLOR_PAIR(1));
    attrset(A_NORMAL); attron(COLOR_PAIR(7)); 
    if (cur_track>=0) a+=putmstr(a,3,20,2,cur_cdname); else a=a+2;
    attroff(COLOR_PAIR(7));
    a=16;
  } else {
    a=17;
    attrset(A_BOLD); attron(COLOR_PAIR(1));
    mvaddstr(a,2,"Artist: "); attroff(COLOR_PAIR(1));
    attrset(A_NORMAL); attron(COLOR_PAIR(6)); a++;
    if (cur_track>=0) a+=putmstr(a,3,20,2,cur_artist); else a=a+1;
    if (countlines(cur_artist,20)<2) a++;
    attroff(COLOR_PAIR(6));
    attrset(A_BOLD); attron(COLOR_PAIR(1));
    mvaddstr(a,2,"Album: "); a++; attroff(COLOR_PAIR(1));
    attrset(A_NORMAL); attron(COLOR_PAIR(7)); 
    if (cur_track>=0) a+=putmstr(a,3,20,2,cur_cdname); else a=a+1;
    attroff(COLOR_PAIR(7));
    a=16;
  }
  /* end of the ARTIST and ALBUM maskarade :) */

  makebox(25,a++,77,LINES-2,0,COLOR_PAIR(1));
  mvaddstr(a-1,50," PROG - SPC <> CLEAR - C ");
  attron(COLOR_PAIR(3)); mvaddch(16,25,ACS_TTEE);
  mvaddch(16,26,ACS_HLINE); mvaddch(16,27,ACS_HLINE);
  mvaddch(17,26,ACS_VLINE); attroff(COLOR_PAIR(3));
  attrset(A_BOLD); attron(COLOR_PAIR(1)); 
  mvaddch(16,28,ACS_HLINE); mvaddch(16,29,ACS_HLINE); 
  mvaddch(16,30,ACS_HLINE); mvaddch(16,31,ACS_HLINE); 
  mvaddch(17,25,ACS_VLINE); attrset(A_NORMAL); attroff(COLOR_PAIR(1));
  height=LINES-a-4;

  sel=sincepressed?selection:cur_track;

  if (cd->trk[sel].songname) b=countlines(cd->trk[sel].songname,60); else b=1;
  c=a+(height-b)/2;
  b=0;
  
  for (n=17; n<LINES-2; n++)
    mvaddstr(n,26,"                                                   ");
  if (cur_track>=0) {
    for (n=sel; (n<=cur_ntracks) && ((c+b)<(LINES-2)); n++) {
      if (sincepressed && ((n==selection) && (n==cur_track))) {
        attron(COLOR_PAIR(8)|A_BOLD);
      } else {
        if ((n==selection) && (sincepressed)) {
          attron(COLOR_PAIR(8)|A_BOLD);
        } else {
          if (n==cur_track) {
            attron(COLOR_PAIR(7)|A_BOLD);
          } else {
            attrset(A_NORMAL);
          }
        }
      }

      if (cd->trk[n].avoid)
        sprintf(buff," %2.2d : ",n);
      else
        sprintf(buff,"[%2.2d]: ",n);
      mvaddstr(c+b,27,buff);
      b+=putmstr(c+b,33,42,MIN(27,(LINES-2)-b-c),cd->trk[n].songname);
      attrset(A_NORMAL);
    }

    b=1;
  
    for (n=sel-1; (n>0) && ((c-b)>=a); n--) {
      if (n==cur_track)
        attron(COLOR_PAIR(7)|A_BOLD);
      else
        attrset(A_NORMAL);
  
      if (cd->trk[n].avoid)
        sprintf(buff," %2.2d : ",n);
      else
        sprintf(buff,"[%2.2d]: ",n); 
        
   /*  for printing the track numbas */    
      if ((c-b-countlines(cd->trk[n].songname,65)+1) >=a)
        mvaddstr(c-b-countlines(cd->trk[n].songname,65)+1,27,buff);
      b+=putmstr(c-b,33,42,-MIN(27,c-a-b+1),cd->trk[n].songname);
      attrset(A_NORMAL);
  
    }


    if (editing) {
      curs_set(1);
      switch(editing) {
        case 1: move(c-1+countlines(cd->trk[selection].songname,42),33+lastlinelen(cd->trk[selection].songname,42)); break;
        case 2: move(17+countlines(cur_artist,20),3+lastlinelen(cur_artist,20)); break;
        case 3: { if (LINES==25) {
                    if (countlines(cur_artist,20)<2) move(19+countlines(cur_artist,20)+countlines(cur_cdname,20),3+lastlinelen(cur_cdname,20));
                    else move(18+countlines(cur_artist,20)+countlines(cur_cdname,20),3+lastlinelen(cur_cdname,20));
                  }
                else move(19+countlines(cur_artist,20)+countlines(cur_cdname,20),3+lastlinelen(cur_cdname,20)); } break;
      }
    } else {
      curs_set(0);
      move(LINES-1, COLS-1);
    }
  }
  
  refresh();
}

deletechar(char *a) {
  int l;
  l=strlen(a);
  if (l) *(a+l-1)=0;
}

appendchar(char *a, char b) {
  char buff[2]; int l;
  buff[0]=b; buff[1]=0;
  strcat(a,buff); 
  if (countlines(a,65)>2) deletechar(a);
  /*                  ^^^
     this is the TAB KEY entry enumerator */
}


void handlechar() {
  int a,n,m;
  char *e;

  if (hilitelen) {
    hilitelen--;
    if (!hilitelen)
      hilite(0);
  }

  if (sincelast) {
    if (sincelast==1)
      what=0;
    sincelast--;
  }

  if (!sincepressed) selection=cur_track;

  if (sincepressed && (!editing)) {
    sincepressed--;
  }
  
  while(!((a=getch())==ERR))
  if (editing) {
    switch (editing) {
      case 1:e=cd->trk[selection].songname; break;
      case 2:e=cd->artist; break;
      case 3:e=cd->cdname; break;
    }
    if (a==127 || a==KEY_BACKSPACE) {
      deletechar(e);
      continue;
    }
    if (a==13 || a==KEY_DOWN) {
      if (editing==1) {
        selection++;
        if (selection>cur_ntracks)
          selection=1;
      } else {
        editing=editing==2?3:2;
      }
      continue;
    }
    if (a==KEY_UP) {
      if (editing==1) {
        selection--;
        if (selection<1) selection=cur_ntracks;
      } else {
        editing=editing==2?3:2;
      }
      continue;
    }
    if ((a==KEY_F(12)) || (a==KEY_F(11))) {
      editing=0;
      savedashit(); 
      return;
    }
    if ((a==9) || ((a>31) && (a<127)))
      appendchar(e,a);
  } else
  {
    switch(a) {
     case KEY_F(1): {
                      hilite(11);
                      sincepressed=0;
                      if (cur_cdmode==CDPLAY) { pause_cd(); break; }
                      if (cur_cdmode==CDPAUZ) { pause_cd(); break; }
                      if (cur_cdmode==CDSTOP || cur_cdmode==CDNULL) {
                      play_cd(1,0,cur_ntracks+1); wait=5; break; }
                    } break;
     case KEY_F(2): {
                      hilite(12);
                      stop_cd();
                      playmode=MODE_NORMAL;
                      sincepressed=0;
                    } break;
     case KEY_F(3): {
                      hilite(13);
                      play_cd((cur_track + cur_ntracks - 2)%cur_ntracks+1,0,cur_ntracks+1);
                      wait=5;
                      sincepressed=0;
                    } break;
     case KEY_F(4): {
                      hilite(14);
                      play_cd((cur_track % cur_ntracks)+1,0,cur_ntracks+1);
                      wait=5;
                      sincepressed=0;
                    } break;
     case KEY_F(5): {
                      hilite(15);
                      sincepressed=0;
                      if (cur_pos_abs>5) {
                        play_chunk((cur_pos_abs-5)*75,cur_cdlen*75);
                        wait=5;
                      }
                    } break;
     case KEY_F(6): {
                      hilite(16);
                      sincepressed=0;
                      if (cur_pos_abs<(cur_cdlen-5)) {
                        play_chunk((cur_pos_abs+5)*75,cur_cdlen*75);
                        wait=5;
                      }
                    } break;
     case '-':
     case KEY_F(7): {
                      hilite(17);
                      muted=0;
                      cur_volume=MAX(0,cur_volume-1);
                      cd_volume(cur_volume,10,22);
                    } break;
     case '+':
     case '=':
     case KEY_F(8): { 
                      hilite(18);
                      muted=0;
                      cur_volume=MIN(22,cur_volume+1);
                      cd_volume(cur_volume,10,22);
                    } break;
     case KEY_F(11):{
                      hilite(23);
                      sincepressed=100;
                      editing=2;
                      sincelast=0; what=0;
                    } break;
     case KEY_F(12):{
                      hilite(23);
                      sincepressed=100;
                      editing=1;
                      sincelast=0; what=0;
                    } break;
     case KEY_UP:   {
                      selection=MAX(1,selection-1);
                      sincelast=what=0;
                      sincepressed=100;
                    } break;
     case KEY_DOWN: {
                      selection=MIN(cur_ntracks,selection+1);
                      sincelast=what=0;
                      sincepressed=100;
                    } break;
     case 'c':
     case 'C':      {
                      sincepressed=100;
                      m=0;
                      for (n=1; n<=cur_ntracks; n++) {
                        if (cd->trk[n].avoid) {
                          for (n=1; n<=cur_ntracks; n++)
                          cd->trk[n].avoid=0;
                          m=1;
                          break;
                        }
                      }
                      if (!m)
                        for (n=1; n<=cur_ntracks; n++)
                          if (n!=cur_track) cd->trk[n].avoid=1;
                    } break;
     case 'a':
     case 'A':      {
                      hilite(19);
                      if (playmode==MODE_AUTOLOOP)
                        playmode=MODE_NORMAL;
                      else
                        playmode=MODE_AUTOLOOP;
                    } break;
    case 'n':
    case 'N':       {
                      hilite(19);
                      if(playmode==MODE_AUTOLOOPONE)
                        playmode=MODE_NORMAL;
                      else
                        playmode=MODE_AUTOLOOPONE;
                      whichtrack=cur_track;
                    } break;
    case 'r':
    case 'R':       {
                      hilite(19);
                      if (playmode==MODE_RANDOM)
                        playmode=MODE_NORMAL;
                      else
                        playmode=MODE_RANDOM;
                      whichtrack=cur_track;
                    } break;
    case 's':
    case 'S':       {
                      hilite(19);
                      if (playmode==MODE_STOPAFTER)
                        playmode=MODE_NORMAL;
                      else
                        playmode=MODE_STOPAFTER;
                      whichtrack=cur_track;
                    } break;
    case 'm':
    case 'M':       {
                      if (muted==0) {
                        muted=1;
                        cd_volume(0,10,22);
                        pislen=10;
                        putinstatus="MUTE  on ";
                      } else {
                        muted=0;
                        cd_volume(cur_volume,10,22);
                        pislen=10;
                        putinstatus="MUTE off ";
                      }
                    } break;
     case '0': case '1':
     case '2': case '3':
     case '4': case '5':
     case '6': case '7':
     case '8': case '9': {
                            hilite(a-'0'?a-'0':10);
                            sincepressed=100;
                            sincelast=30;
                            what=(what*10)%100+a-'0';
                            if (what>0) if (what<=cur_ntracks) selection=what;
                          } break;
     case ' ':      {
                      if (selection!=cur_track)
                      cd->trk[selection].avoid=cd->trk[selection].avoid?0:1;
                      sincelast=what=0;
                      sincepressed=100;
                    } break;
     case '.':      {
                      hilite(20);
                      stop_cd();
                      eject_cd();
                      sincelast=0; what=0;
                    } break;
     case '\\':     {
                      updatedisp(1);
                    } break;                                                             
     case 13:       {
                      if (cd->trk[selection].avoid)
                      cd->trk[selection].avoid=0;
                      play_cd(selection,0,cur_ntracks+1);
                      wait=5;
                      sincelast=what=0;
                      sincepressed=0;
                    } break;
     case 27: { clear(); endwin(); exit(0); } break;
    }
  }
}

int wasout;

void checkit()
{
  int qwe;

  if (cur_track==0) return;
  if (cur_cdmode!=CDPLAY) return;
  if (cd->trk[cur_track].avoid==0) return;

  for (qwe=cur_track+1; qwe<=cur_ntracks; qwe++) {
    if (cd->trk[qwe].avoid==0) {
      wait=5;
      play_cd(qwe,0,cur_ntracks+1);
      return;
    }
  }

  if (playmode!=MODE_AUTOLOOP) { stop_cd(); playmode=MODE_NORMAL; return; }
 
  for (qwe=1; qwe<=cur_track; qwe++) {
    if (cd->trk[qwe].avoid==0) {
      wait=5;
      play_cd(qwe,0,cur_ntracks+1);
      return;
    }
  }
}

void autoact()
{
  int qwe; 

  if (cd_status()!=1) {
    playmode=MODE_NORMAL;
    wasout=1;
    editing=0;
    selection=1;
    return;
  }
  if (wasout) {
    if (autoplay) {
      playmode=MODE_AUTOLOOP;
      wait=5;
      if (wasout!=2)
        play_cd(0,0,cur_ntracks+1);
      wasout=0;
      return;
    }
    wasout=0;
    selection=1;
    editing=0;
  }
  if (playmode==MODE_NORMAL) { checkit(); return; }
  if (playmode==MODE_AUTOLOOP) {
    if (!(cur_cdmode==CDPLAY || cur_cdmode==CDPAUZ)) {
      if (!initwait) {
        play_cd(1,0,cur_ntracks+1);
      }
    } else checkit();
    return;
  }
  if (!wait) {
    if (playmode==MODE_AUTOLOOPONE) {
      if (cur_track!=whichtrack) {
        play_cd(whichtrack,0,cur_ntracks+1);
        wait=5;
      } else checkit();
      return;
    }
    if (playmode==MODE_STOPAFTER) {
      if (cur_track!=whichtrack) {
        stop_cd();
        playmode=MODE_NORMAL;
      }
      return;
    }
    if (playmode==MODE_RANDOM) {
      if (cur_track!=whichtrack) {
        play_cd(rand() % cur_ntracks+1,0,cur_ntracks+1);
        wait=5;
      }
      return;
    }
  } else {
    if (wait==1) {
      whichtrack=cur_track;
    }
    wait--;
  }
}

void main (void)
{
  WINDOW *a;
  
  printf("\n\r[1;35mACDC[m - popular [1;32mAUDIO Compact Disk[m player 4 LiNUX v1.0\n\r");
  printf("copyright (c) [1;31mC[1;34mM[1;33mt[m 1996\n\r");
  printf("\n\rInitializing...\n\r");
  sleep(2);
  switch (cd_status()) {
    case 0: { printf("\n\r[1;31mERROR:[m   Please insert an AUDIO Compact Disk in the CD-drive...\n\n\r");
    exit(3); } break;
  }
  if (cur_ntracks<2) {
    printf("\n\r[1;31mERROR:[m   Please insert an AUDIO Compact Disk in the CD-drive...\n\n\r");
    exit(3);
  }
  a=initscr();
  start_color();
  init_pair(1,COLOR_WHITE,COLOR_BLACK);
  init_pair(2,COLOR_BLUE,COLOR_BLACK);
  init_pair(3,COLOR_RED,COLOR_BLACK);
  init_pair(4,COLOR_GREEN,COLOR_BLACK);
  init_pair(5,COLOR_CYAN,COLOR_BLACK);
  init_pair(6,COLOR_MAGENTA,COLOR_BLACK);
  init_pair(7,COLOR_YELLOW,COLOR_BLACK);
  init_pair(8,COLOR_YELLOW,COLOR_BLUE);
  cbreak();
  noecho();
  nonl();
  refresh();
  timeout(0);
  keypad(a,TRUE);
  init();
  wasout=2;

  if ( (LINES!=25) && (LINES!=28) && (LINES!=30) && (LINES!=34) )
  { 
    printf("[1;31mERROR:[m\n\n\r   [1;35mACDC[m currently supports these modes:\n\r");
    printf("default text mode:  [1;37m80x25[m  -linux mode is [1;37m0[m\n\r");
    printf("special text mode:  [1;37m80x28[m  -linux mode is [1;37m3[m\n\r");    
    printf("normal text mode :  [1;37m80x30[m  -linux mode is [1;37m4[m\n\r");
    printf("special text mode:  [1;37m80x34[m  -linux mode is [1;37m5[m\n\r");
    printf("\n\n\r");
    endwin(); exit(3);
  } 
  printf("\n\rDone.\n\rrunning...\n\r"); sleep(1);
  
  updatedisp(1);

  for (;;) {
    if (initwait) initwait--;
    handlechar();
    updatedisp(0);
    autoact(); 
    usleep(50000);
  }

  endwin();
}
